明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 1884|回复: 3

關閉圖層問題

[复制链接]
发表于 2009-5-12 18:54:00 | 显示全部楼层 |阅读模式
我在自己的程序前面建立了名为 1,2,3的图层,在不同的图层绘制了不同的实体.

在某一步时,我想关闭图层1和2,只显示图层3的实体,请问如何用objectarx实现,谢谢
发表于 2009-5-16 09:17:00 | 显示全部楼层
遍历图层表的记录,使用AcDbLayerTableRecord 对象的

void setIsOff(bool off);

关闭图层

发表于 2009-5-16 12:21:00 | 显示全部楼层
  1. //-------------------------------------------------------------------------------
复制代码
  1. //将关闭层1、2,显示层3,以下内容在ARX08测试成功
复制代码
  1. //多看书,这个不难
复制代码
void fun()
{
AcDbLayerTable *pLayerTable;
acdbHostApplicationServices()->workingDatabase()->getLayerTable( pLayerTable, AcDb::kForRead );
AcDbLayerTableIterator *pItr;
AcDbLayerTableRecord *pLayerTableRecord;
ACHAR *layerName;
pLayerTable->newIterator( pItr );
for ( pItr->start(); !pItr->done(); pItr->step() )
{
  pItr->getRecord( pLayerTableRecord, AcDb::kForWrite );
  pLayerTableRecord->getName( layerName );
  if ( _tcscmp( layerName, _T("1")) == 0 || _tcscmp( layerName, _T("2")) ==0 )
  {
   pLayerTableRecord->setIsOff( true );
  }
  if ( _tcscmp( layerName, _T("3")) == 0 )
  {
   pLayerTableRecord->setIsOff( false );
  }
  pLayerTableRecord->close();
  free( layerName );
}
delete pItr;
pLayerTable->close();
}
发表于 2009-5-18 21:53:00 | 显示全部楼层

再贴一个,希望对你有帮助

Adesk::Boolean SetIsOff (const char* lyrname,
          bool off)
{
 AcDbLayerTable *pLyrTable;
 AcDbLayerTableRecord *pLyrTblRecord;
 
 AcDbDatabase *pCurDb = NULL;
 pCurDb = acdbHostApplicationServices()->workingDatabase();
 
 // 获得当前图形的层表
 pCurDb->getLayerTable(pLyrTable, AcDb::kForRead);
 AcDbObjectId lyrId;
 // 是否已经包含指定的层表记录
 if (!pLyrTable->has(lyrname) && !(lyrname == "*"))
 {
  pLyrTable->close();
  return Adesk::kFalse;
 }
 else
 {
  pLyrTable->getAt(lyrname, lyrId);
 }
 AcDbLayerTableIterator *pItr;
 pLyrTable->newIterator(pItr);
 if (lyrname == "*")
 {
  for (pItr->start(); !pItr->done(); pItr->step())
  { // 遍历器记录
   pItr->getRecord(pLyrTblRecord, AcDb::kForWrite); 
   pLyrTblRecord->setIsOff(off);
   pLyrTblRecord->close();
  }
 }
 else
 {
  for (pItr->start(); !pItr->done(); pItr->step())
  { // 遍历器记录
   if(pItr->seek(lyrId) == Acad::eOk)
   {
    pItr->getRecord(pLyrTblRecord, AcDb::kForWrite); 
    pLyrTblRecord->setIsOff(off);
    pLyrTblRecord->close();
    break;
   }
  }
 }
 delete pItr;
 
 pLyrTable->close();
 return Adesk::kTrue;
}

您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-25 14:53 , Processed in 0.188769 second(s), 24 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表